/*
                    TTTTTTT    OOOOO    7777777
                       T      O     O        7
                       T      O     O       7     77777  000
                       T      O     O      7         7  0   0
                       T      O     O     7         7   0   0
                       T       OOOOO     7         7     000

                             EMULATEUR

                          Par Sylvain HUET
                    (Sylvain.Huet@inria.fr)
                               1996

  video.c : routines video de l'emulateur (+gestion memoire)

*/
#include <InterfaceKit.h>

#include "monitor.h"
#include "emuto7.h"

#define 	nbtouche 	68
#define 	nkey 		3

rgb_color rgb_col[]=
{
	{127,127,127,  0},
	{255,127,127,  0},
	{127,255,127,  0},
	{255,255,127,  0},
	{127,127,255,  0},
	{255,127,255,  0},
	{127,255,255,  0},
	{255,127,  0,  0},
	{  0,  0,  0,  0},
	{255,  0,  0,  0},
	{  0,255,  0,  0},
	{255,255,  0,  0},
	{  0,  0,255,  0},
	{255,  0,255,  0},
	{  0,255,255,  0},
	{255,255,255,  0}
};


const 	long			MSG_REDRAW = 1;
extern	BWindow			*the_window;
extern	BView			*main_view;

char		*nomstat=NULL;
int			screen;
int			col[16];
char		modif[1040];
int			conv[8192];

int			tch[nkey];
int			lkey[256];
int			ckey[256];
extern FILE	*fl;
FILE		*fk7;
int			crayx,crayy;
int			lasttour;
int 		nbwait;
int 		gainit;
int 		pa1,pb1;
int			pain1,paout1,crain1;
int			pbin1,pbout1,crbin1;
int			pain2,paout2,crain2;
int			pbin2,pbout2,crbin2;

int	codel[]=
{0x01,0x01,0x02,0x02,0x02,0x02,0x02,0x02,0x04,0x08,0x10,0x20,0x40,0x80
,0x04,0x08,0x10,0x20,0x40,0x80,0x80,0x40,0x20,0x10
,0x04,0x08,0x10,0x20,0x40,0x80,0x80,0x40,0x20,0x10
,0x04,0x08,0x10,0x20,0x40,0x80,0x80,0x40,0x20,0x10
,0x02,0x04,0x02,0x04,0x08,0x80
,0x04,0x08,0x04,0x08,0x10,0x20,0x40,0x08
,0x00,0x00,0x00,0x00,0x00
,0x00,0x00,0x00,0x00,0x00
};
int	codec[]=
{0x01,0x01,0x80,0x40,0x20,0x10,0x08,0x02,0x02,0x02,0x02,0x02,0x02,0x02
,0x80,0x80,0x80,0x80,0x80,0x80,0x40,0x40,0x40,0x40
,0x20,0x20,0x20,0x20,0x20,0x20,0x10,0x10,0x10,0x10
,0x08,0x08,0x08,0x08,0x08,0x08,0x04,0x04,0x04,0x04
,0x01,0x01,0x04,0x04,0x04,0x01
,0x40,0x40,0x10,0x10,0x01,0x01,0x01,0x01
,0xfe,0xfb,0xfd,0xf7,0x1
,0xef,0xbf,0xdf,0x7f,0x2
};

uchar be_codes[]=
{
	0x4b,0x56,0x20,0x11,0x35,0x47,0x21,0x57,0x61,0x62,0x63,0x36,0x1f,0x1e,
	
	0x12,0x13,0x14,0x15,0x16,0x17,0x18,0x19,0x1a,0x1b,
	0x27,0x28,0x29,0x2a,0x2b,0x2c,0x2d,0x2e,0x2f,0x30,
	0x3c,0x3d,0x3e,0x3f,0x40,0x41,0x42,0x43,0x44,0x45,
	0x4c,0x4d,0x4e,0x4f,0x50,0x51,
	
	0x1c,0x1d,0x31,0x32,0x46,0x52,0x53,0x5e,	
	
	0x38,0x48,0x4a,0x59,0x49,
	0x38,0x48,0x4a,0x59,0x49
};

void inicray()
{
  crayx=-1;
}

void inikey(char *name)
{
  int	i,key;
  
  for(i=0;i<256;i++)
  {
    lkey[i]=0;
    ckey[i]=255;
  }
  tch[0]=tch[1]=0;

  for(i=0;i<nbtouche;i++)
  {
    key=be_codes[i];
    lkey[key&255]=  codel[i];
    ckey[key&255]=(~codec[i])&255;
  }
  
  buf[0xe7cc]=0;
  buf[0xe7cd]=0;
  buf[0xe7ce]=0;
  buf[0xe7cf]=0;
}

void newcass(char *c)
{
  if (fk7) fclose(fk7);
  if ((fk7=fopen(c,"r+"))==NULL) fk7=fopen(c,"w+");
  if (fk7==NULL) if (fk7=fopen(c,"r")) printf("LECTURE SEULE\n");
  if (fk7==NULL) printf("impossible\n");
  else
    printf("cassette %s\n",c);
}

void avanck7(long k)
{
  if (fk7==NULL)
    printf("impossible\n");
  else
    {
      fseek(fk7,k,0);
      printhx(ftell(fk7),4);
      printf(" : nouvelle position\n");
    }
}

void inik7()
{
  fk7=NULL;
}

void iniscreen(char *name)
{
  	int	i,j,k,l,n;
    
  	for (i=0;i<16;i++)
  	{
		col[i]=index_for_color(rgb_col[i]);
    }
    
  	for(i=0;i<8192;i++) conv[i]=(i%40)*25+(i/320);
  	inikey(name);
  	inicray();
  	inik7();
  	lasttour=4;
}

void refreshv()
{
  	uchar	*fr;
  	uchar	*fd;
  	uchar	*p;
  	uchar	*q;
  	uchar	*tes;
  	uchar	cl;  
  	uchar 	pattern;
  	uchar	fgcol;
  	uchar	bgcol;
  	ulong	off=0;
  	extern uchar *bits;
  	extern ulong xmod;
	long tmp1=xmod*20;
  
  	fr =(uchar *)&buf[0x04000];		// data buffer
  	fd =(uchar *)&buf[0x10000];		// color buffer
  	tes=(uchar *)modif;
  	
	for(int x=0;x<320;x+=8)
	{
        p	= fr;
        q	= fd; 
		off = tmp1;

		for(int y=0;y<200;y++)
		{
        	if ((y&0x07)==0)
          	{
              	if (*tes)	
              	{
              	  	*(tes++)=0;
              	}
              	else	
              	{
                  	y	   += 7;
                  	off	   += xmod*8;
                  	p	   += 320;
                  	q	   += 320;
                  
                  	tes++;
                  	continue;
              	}	
          	}
            cl		=  *q;
          	pattern	= (*p)&255;

			if(cl&0x80)
			{
				bgcol=col[(cl&0x07)+8];
			}
			else
			{
				bgcol=col[(cl&0x07)  ];
			}

			if(cl&0x40)
			{
				fgcol=col[((cl>>3)&0x07)+8];
			}
			else
			{
				fgcol=col[((cl>>3)&0x07)  ];
			}

			for(int i=0;i<8;i++)
			{
				if(pattern&(1<<(7-i)))
				{
					bits[off+x+i+20]=fgcol;
				}
				else
				{
					bits[off+x+i+20]=bgcol;				
				}
			}

			off+=xmod;

          	p+=40;
          	q+=40;
          
		}		
      	fr+=1;
      	fd+=1;
	}

  	if ((lasttour!=(buf[0xe7c3]&0x74)))
    {
	    lasttour=(buf[0xe7c3]&0x74);
	    cl=(lasttour&0x70)+((lasttour&4)<<5);
	    cl=cl>>1;

		if(cl&0x40)
		{
			fgcol=col[((cl>>3)&0x07)+8];
		}
		else
		{
			fgcol=col[((cl>>3)&0x07)  ];
		}

		long tmp2=xmod*220;	

		memset(bits,fgcol,tmp1);
		memset(bits+tmp2,fgcol,tmp1);
			
		for(int h=tmp1;h<tmp2;h+=xmod)
		{
			memset(bits+h,fgcol,20);
			memset(bits+h+340,fgcol,20);
		}
	}
	
	the_window->PostMessage(MSG_REDRAW);
}

void refreshsc()
{
  int	i;
  
  for(i=0;i<1000;i++) modif[i]=1;
  lasttour=4;
  refreshv();
}

long loads(long k)
{
  int i,j,pb;
  
  if ((k&0xffc0)==0xe7C0)
    {
      if (k==0xe7c0) return 0x81;
      
      if ((k&0xfffc)==0xe7c8)
	{
	  if ((k==0xe7c8)&&(buf[0xe7ca]&4))
	    {
	      pb=(0x80>>(pbout1&7));
	      pain1=0xff;
	      for(i=0;i<nkey;i++)
		pain1&=((pb&lkey[tch[i]])?ckey[tch[i]]:0xff);
	      return ((paout1&buf[0xe7c8])+(pain1&(~buf[0xe7c8])))&255;
	    }
	  if ((k==0xe7c9)&&(buf[0xe7cb]&4))
	    return ((pbout1&buf[0xe7c9])+(pbin1&(~buf[0xe7c9])))&255;
	  if (k==0xe7ca) return (buf[0xe7ca]&0x7f)+(crain1&0x80);
	  if (k==0xe7cb) return (buf[0xe7cb]&0x7f)+(crbin1&0x80);
	}
      
      if ((k&0xfffc)==0xe7cc)
	{
	  if ((k==0xe7cc)&&(buf[0xe7ce]&4))
	    return ((paout2&buf[0xe7cc])+(pain2&(~buf[0xe7cc])))&255;
	  if ((k==0xe7cd)&&(buf[0xe7cf]&4))
	    return ((pbout2&buf[0xe7cd])+(pbin2&(~buf[0xe7cd])))&255;
	  if (k==0xe7ce) return (buf[0xe7ce]&0x7f)+(crain2&0x80);
	  if (k==0xe7cf) return (buf[0xe7cf]&0x7f)+(crbin2&0x80);
	  
	}
      if (k==0xe7e7)
	{
	  if (gainit>=6666) gainit-=6666;
	  if (gainit>=4266) return 0;
	  return 128;
	}	
      return buf[k]&255;
    }
  if ((k>=0xa000)&&(k<0xe000))
    {
      i=0;
      if (buf[0xe7c9]&8) i|=buf[k];
      if (buf[0xe7c9]&0x10) i|=buf[k+0x8000];
      if (buf[0xe7c9]&0x18) return i&255;
      return 0x5e;
    }
  if (((k&0xe000)==0x4000)&&(!(buf[0xe7c3]&1))) k+=0xc000;
    return buf[k]&255;
}

long loadl(long k)
{
  int i;
  
  if ((k&0xffc0)==0xe7C0)
    {          
      return ((loads(k)<<8)+(loads(k+1)&255))&0xffff;
    }
  if ((k>=0xa000)&&(k<0xe000))
    {
      i=0;
      if (buf[0xe7c9]&8) i|=((buf[k]&255)<<8)+(buf[k+1]&255);
      if (buf[0xe7c9]&0x10) i|=((buf[k+0x8000]&255)<<8)+(buf[k+0x8000+1]&255);
      if (buf[0xe7c9]&0x18) return i&0xffff;
      return 0x5e5e;
    }
  if (((k&0xe000)==0x4000)&&(!(buf[0xe7c3]&1))) k+=0xc000;
  return ((buf[k]&255)<<8)+(buf[k+1]&255);
}

int stocs(long k,long val)
{
  if (k<0x6000)
    {
      if (k<0x4000) return 0;
      modif[conv[k-0x4000]]=1;
      if (!(buf[0xe7c3]&1)) k+=0xc000;
      buf[k]=val;
      return 0;
    }
  if (k>endmem)
    {
      if ((k&0xffc0)==0xe7C0)
	{
	  if ((k==0xe7c8)&&(buf[0xe7ca]&4))
	    {
	      paout1=val;
	      return 0;
	    }
	  if ((k==0xe7c9)&&(buf[0xe7cb]&4))
	    {
	      pbout1=val;
	      return 0;
	    }  
	  
	  if ((k==0xe7cc)&&(buf[0xe7ce]&4))
	    {
	      paout2=val;
	      return 0;
	    }	
	  if ((k==0xe7cd)&&(buf[0xe7cf]&4))
	    {
	      pbout2=val;
	      return 0;
	    }	
	  
	  if (k==0xe7c3) val|=128;
	  buf[k]=val;
	} 
      return 0;
    }
  
  if (k>=0xa000)
    {
      if (buf[0xe7c9]&8) buf[k]=val;
      if (buf[0xe7c9]&0x10) buf[k+0x8000]=val;
      return 0;
    }
  buf[k]=val;
  return 0;
}

int stocl(long k,long val)
{
  if (k<0x6000)
    {
      if (k<0x4000) return 0;
      modif[conv[k-0x4000]]=1;
      modif[conv[k+1-0x4000]]=1;
      if (!(buf[0xe7c3]&1)) k+=0xc000;
      buf[k+1]=val;
      val>>=8;
      buf[k]=val;
      return 0;
    }
  if (k>endmem)
    {
      if ((k&0xffc0)==0xe7C0)
        {              
          stocs(k,val>>8);
          stocs(k+1,val);
        }	
      return 0;
    }
  if (k>=0xa000)
    {
      if (buf[0xe7c9]&8) buf[k+1]=val;
      if (buf[0xe7c9]&0x10) buf[k+0x8000+1]=val;
      val>>=8;
      if (buf[0xe7c9]&8) buf[k]=val;
      if (buf[0xe7c9]&0x10) buf[k+0x8000]=val;
      return 0;
    }
  buf[k+1]=val;
  val>>=8;
  buf[k]=val;
  return 0;
}


long	compt;
int	quitf;

int bouclex()
{
  	int	i,j,k;
  	int	key;
  	int   ninst;

  	j=0;
  	compt=0;
  	for(i=0;i<nkey;i++) tch[i]=0;
  	quitf=1;

  	pain2=paout2=crain2=255;
  	pbin2=pbout2=crbin2=255;
  
  	gainit=0;
  	ninst=0;

  	while(quitf)
    {
    	for(i=0;i<11000;i++)
        {
        	exe6809();
          	for(k=0;k<nbwait;k++);
          	gainit++;
        }
      	if (gainit>=6666) gainit-=6666;
      
      	if ((++j)==3)
        {
        	if (!(ccrest&0x10))
            {
              	ccrest|=0x80;
              	pshsr(0xff);
              	ccrest|=0x10;
              	pc=((buf[0xfff8]<<8)+(buf[0xfff9]&255))&0xffff;
            }
          	j=0;
		}
      	refreshv();
      
	    BPoint pos;
	    ulong buttons;
		key_info ki;
		bool pressed=FALSE;
      
	    the_window->Lock();
	    main_view->MakeFocus();
		main_view->GetMouse(&pos,&buttons);

		if(the_window->IsActive())
		{
			main_view->GetKeys(&ki,FALSE);
			for(int key=0;key<nbtouche;key++)
			{

				if((ki.key_states[be_codes[key]>>3] & (1<<(7-(be_codes[key]%8))))) pressed=TRUE; else pressed=FALSE;

				if(key>57)
				{
					if(pressed)
					{
		            	if ((i=ckey[be_codes[key]])!=255)
	              		{
	                		if (i==0xfe)
	                  		{
	                    		pbin2&=0xbf;
	                    		crain2&=0x7f;
	                  		}
	                		if (i==0xfd)
	                  		{
	                    		pbin2&=0x7f;
	                    		crbin2&=0x7f;
	                  		}
	                		if (i<0xfd) pain2&=~i;
  	            		}
  	            	}
  	            	else
  	            	{
   	              		if ((i=ckey[be_codes[key]])!=255)
                		{
                  			if (i<0xfd) pain2|=i;
                  			if (i==0xfe) 	
                    		{
                      			pbin2|=0x40;
                      			crain2|=0x80;
                    		}
                  			if (i==0xfd)
                    		{
                      			pbin2|=0x80;
                      			crbin2|=0x80;
                    		}
                		}
  	            	}
  	            }
				else if(pressed)	
				{
					i=0;
					while((i<nkey)&&(tch[i]!=be_codes[key])) i++;
					if (i==nkey)
					{
						i=0;
						while((i<nkey)&&(tch[i])) i++;
						if (i==nkey) i=0;
						tch[i]=be_codes[key];
					}
				}
				else
				{
					for(i=0;i<nkey;i++) if (tch[i]==be_codes[key]) tch[i]=0;
				}
			}
   		}
      
      	pos.x-=20;
      	pos.y-=20;
      
	    if((pos.x>0)&&(pos.x<640))
	    {
	        if((pos.y>0)&&(pos.y<400))
			{
	   	   		if(buttons&B_PRIMARY_MOUSE_BUTTON)
	   	   	    {
	                buf[0xe7c3]|=2;
	   	   	    }
	   	   	    else
	   	   	    {
	   	   	    	buf[0xe7c3]&=~2;
	   	   	    }
   	   	      
	   	   	    if(buttons&B_SECONDARY_MOUSE_BUTTON)
	   	   	    {
	                quitf=0;
	                the_window->Hide();
	   	   	    }
	   	   	    crayx=pos.x;
	   	   	    crayy=pos.y;
	   	   	}
	   	   	else crayx=-1;
	    }
	    else crayx=-1;

	    the_window->Unlock();
    }
  	return ninst;
}
